﻿Public Class Form1

    Private myApi As New KivaVBLibrary.KivaAPI

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btntestApi.Click

        'use login and password at kiva.org as basic auth
        myApi.userName = TxtUsername.Text
        myApi.userPassword = TxtPassword.Text

        'retrieve the dataset from the API
        Dim ds As DataSet

        'use TxtLender (name as string) of a lender 
        ds = myApi.GetLender(TxtLender.Text)

        PrintDataSet(ds)
        PrintDataRecords(ds)

    End Sub




    Public Sub PrintDataRecords(ByVal ds As DataSet)

        ' Print out all tables and their columns
        Dim iRow As DataRow
        Dim iCol As DataColumn
        For Each table As DataTable In ds.Tables
            For Each iRow In table.Rows
                For Each iCol In table.Columns
                    RTLender.AppendText(iCol.ToString)
                    RTLender.AppendText(vbTab & iRow(iCol.ToString).ToString)
                    RTLender.AppendText(vbCrLf)
                Next
            Next
        Next  ' For Each table  


    End Sub

    Public Sub PrintDataSet(ByVal ds As DataSet)

        ' Print out all tables and their columns  
        For Each table As DataTable In ds.Tables
            RTTableSet.AppendText(vbCrLf & "TABLE " & table.TableName)
            RTTableSet.AppendText(vbCrLf & "Total # of rows: " & table.Rows.Count)
            RTTableSet.AppendText(vbCrLf & "---------------------------------------------------------------")

            For Each column As DataColumn In table.Columns
                RTTableSet.AppendText(vbCrLf & column.ColumnName & " " & column.DataType.ToString())
            Next  ' For Each column  
            RTTableSet.AppendText(vbCrLf)

        Next  ' For Each table  

        ' Print out table relations  
        For Each relation As DataRelation In ds.Relations
            RTTableSet.AppendText(vbCrLf & "RELATION: " & relation.RelationName)
            RTTableSet.AppendText(vbCrLf & "---------------------------------------------------------------")
            RTTableSet.AppendText(vbCrLf & "Parent: " & relation.ParentTable.TableName)
            RTTableSet.AppendText(vbCrLf & "Child: " & relation.ChildTable.TableName)
            RTTableSet.AppendText(vbCrLf)
        Next  ' For Each relation  

    End Sub



End Class
