﻿Imports System.Net
Imports System.Text

Namespace KivaVBLibrary

    Public Class KivaAPI

        Private _UrlFactory As New KivaVBLibrary.URLFactory

        Private _AppID As String = "org.juust.kivareader"
        Private _UserAgent As String = "KivaReader (http://www.juust.org) appid:" & _AppID

        Private _userName As String = ""
        Private _userPassword As String = ""

        Public Property AppID As String
            Get
                Return _AppID
            End Get
            Set(ByVal value As String)
                _AppID = value
            End Set
        End Property

        Public Property userName As String
            Get
                Return _userName
            End Get
            Set(ByVal value As String)
                _userName = value
            End Set
        End Property

        Public Property userPassword As String
            Get
                Return _userPassword
            End Get
            Set(ByVal value As String)
                _userPassword = value
            End Set
        End Property

        Public Sub New()
        End Sub


        Public Sub SetBasicAuthHeader(ByVal request As HttpWebRequest)

            Dim authInfo As String = Me.userName + ":" + Me.userPassword
            authInfo = Convert.ToBase64String(Encoding.Default.GetBytes(authInfo))
            With request
                .Headers("Authorization") = "Basic " + authInfo
                .Accept = "application/xml"
                .UserAgent = "KivaReader 1.0.0.0 (juust.org)"
                .AllowAutoRedirect = False
                .Timeout = 5000
                .KeepAlive = False
            End With
        End Sub

        Public Function GetLender(ByVal LenderID As String) As DataSet

            Dim MyRequest As HttpWebRequest

            '_UrlFactory.GetLenderURL(LenderID) returns  
            MyRequest = HttpWebRequest.Create(_UrlFactory.GetLenderURL(LenderID))
            With MyRequest
                .Method = "GET"
            End With


            Dim dsLender As DataSet
            dsLender = New DataSet()
            Using MyResponse As HttpWebResponse = MyRequest.GetResponse()
                dsLender.ReadXml(MyResponse.GetResponseStream())
            End Using
            MyRequest = Nothing

            Return dsLender

        End Function

    End Class

End Namespace
