﻿Namespace KivaVBLibrary

    Public Class URLFactory

        Public baseURL As String = "http://api.kivaws.org/v1/"
        Public urlSuffix As String = ".xml"

        Public Function GetLenderURL(ByVal UID As String) As String
            Return baseURL + "lenders/" + UID + urlSuffix
        End Function

        Public Function GetLenderLoansURL(ByVal UID As String, Optional ByVal pageNumber As Integer = 1) As String
            Return baseURL + "lenders/" + UID + "/loans" + urlSuffix + "?page=" + pageNumber.ToString()
        End Function


        Public Function GetAllPartnersURL(Optional ByVal pageNumber As Integer = 1) As String
            Return baseURL + "partners" + urlSuffix + "?page=" + pageNumber.ToString()
        End Function

        Public Function GetLoanURL(ByVal LoanID As String) As String
            Return baseURL + "loans/" + LoanID.ToString() + urlSuffix
        End Function

        Public Function GetNewestLoansURL(Optional ByVal pageNumber As Integer = 1) As String
            Return baseURL + "loans/newest" + urlSuffix + "?page=" + pageNumber.ToString()
        End Function

        Public Function GetLoanLendersURL(ByVal UID As String, Optional ByVal pageNumber As Integer = 1) As String
            Return baseURL + "loans/" + UID + "/lenders" + urlSuffix + "?page=" + pageNumber.ToString()
        End Function

        Public Function GetLoansURL(Optional ByVal status As String = "", Optional ByVal gender As String = "", Optional ByVal sector As String = "", Optional ByVal region As String = "", Optional ByVal countryCode As String = "", Optional ByVal partnerID As String = "", Optional ByVal query As String = "", Optional ByVal pageNumber As Integer = 1) As String
            Dim searchURL As String = "http://api.kivaws.org/v1/loans/search.xml?&page=" + pageNumber
            If status <> "" Then searchURL = searchURL + "&status=" + status
            If gender <> "" Then searchURL = searchURL + "&gender=" + gender
            If sector <> "" Then searchURL = searchURL + "&sector=" + sector
            If region <> "" Then searchURL = searchURL + "&region=" + region
            If countryCode <> "" Then searchURL = searchURL + "&countryCode=" + countryCode
            If partnerID <> "" Then searchURL = searchURL + "&partnerID=" + partnerID
            If query <> "" Then searchURL = searchURL + "&query=" + query
            Return searchURL
        End Function

    End Class

End Namespace
